// $Id: hlrTransaction.h,v 1.3 2003/12/02 12:00:57 guarise Exp $
// -------------------------------------------------------------------------
// Copyright (c) 2001-2002, The DataGrid project, INFN, 
// All rights reserved. See LICENSE file for details.
// -------------------------------------------------------------------------
// Authors: Andrea Guarise <andrea.guarise@to.infn.it>
/***************************************************************************
 * Code borrowed from:
 *  authors   : 
 *             
 *  
 ***************************************************************************/

#ifndef HLR_TRANSACTION_H
#define HLR_TRANSACTION_H


#include<string>
#include<iostream>
#include<sstream>
#include"edg/workload/dgas/hlr_api/hlrResource.h"
#include"edg/workload/dgas/hlr_api/hlrUser.h"
#include"edg/workload/dgas/hlr_api/hlrFund.h"
#include"edg/workload/dgas/hlr_api/hlrTransIn.h"
#include"edg/workload/dgas/hlr_api/hlrTransOut.h"
#include"edg/workload/dgas/common/libdgas_log.h"

using namespace std;

enum type{out,in,nd};

class hlrTransaction {
	public:
		int tid;
		type   tType;  //Mandatory!!!
		string id;
		string fromId;
		string toId;
		string fromHlrUrl;
		string toHlrUrl;
		int amount;
		string timeStamp;
		string logData;

		hlrTransaction ( int _tid = 0,
			        type _tType = nd,	
				string _id = "",
				string _fromId = "",
				string _toId = "",
				string _fromHlrUrl = "",
				string _toHlrUrl = "",
				int _amount=0,
				string _timeStamp="",
				string _logData=""
			       );


		int get();	//plain get method
		int get(vector<hlrTransaction>& tv);//get item matchin with proper object
		int getKeys(vector<int>& keys); //ket in and out keys matching with proper objects
		int put();
		int del();
		int del(int& start, int& end); //delete range of entries
		bool exists(); //report if the given transaction exists or not.

		int process();// process the transaction and credit/debit the 
			      // account.

friend ostream& operator << ( ostream& os, const hlrTransaction& tr );

	private:
		int getIn();	//plain get method
		int getKeysIn(vector<int>& keys); //ket in and out keys matching with proper objects
		int getOut();	//plain get method
		int getKeysOut(vector<int>& keys); //ket in and out keys matching with proper objects
		int putIn();
		int putOut();
		int delIn();
		int delOut();
		bool existsIn();
		bool existsOut();
		bool isIn(string& acctType);
		bool isOut(string& acctType);
		int processIn(string& acctType);
		int processOut(string& acctType);
		
};

#endif
